unit server1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, xmldom, XMLIntf, msxmldom, XMLDoc, StdCtrls, IdBaseComponent,
  IdComponent, IdTCPServer, IdHTTPServer;

type
  TForm1 = class(TForm)
    XMLDocument1: TXMLDocument;
    IdHTTPServer1: TIdHTTPServer;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    Button2: TButton;
    GroupBox2: TGroupBox;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure IdHTTPServer1CommandGet(AThread: TIdPeerThread;
      RequestInfo: TIdHTTPRequestInfo; ResponseInfo: TIdHTTPResponseInfo);
  private
    { Private declarations }
  public
    { Public declarations }
    function VyhledejSpojeni(const odkud, kam:string):string;//, pres: string; const odjezd, prestupy, spojeni: integer): string;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    Edit1.Text := OpenDialog1.FileName;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  OpenDialog1.InitialDir := ExtractFileDir(Application.ExeName);
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  v: integer;
  node: IXMLNode;
begin
  if not TryStrToInt(Edit2.Text, v) then
  begin
    ShowMessage('Chybn slo portu');
    exit;
  end;
  IdHTTPServer1.DefaultPort := v;
  GroupBox1.Visible := false;
  Memo1.Lines.Add('Probh aktivace serveru');
  IdHTTPServer1.Active := true;
  Memo1.Lines.Add('  ..ok');
  if IdHTTPServer1.Active then;
  Memo1.Lines.Add('Natm jzdn dy');
  try
    XMLDocument1.LoadFromFile(Edit1.Text);
    Memo1.Lines.Add('  ..ok');
    node := XMLDocument1.DocumentElement;
    if node.NodeName = 'Linky' then;
  except
    on E: Exception do
      Memo1.Lines.Add('Chyba pi natn: ' + E.Message);
  end;
end;

procedure DostanStrZParametru(const slovo, celyparam: string; var vystup: string);
begin
  if Copy(celyparam, 1, length(slovo)) = slovo then
  begin
    vystup := Copy(celyparam, Length(slovo) + 2, length(celyparam));
  end;
end;
procedure DostanIntZParametru(const slovo, celyparam: string; var vystup: integer);
var
  s: string;
  i: integer;
begin
  if Copy(celyparam, 1, length(slovo)) = slovo then
  begin
    s := Copy(celyparam, Length(slovo) + 2, length(celyparam));
    for i := 1 to length(s) do
      if not(s[i] in ['0'..'9']) then
        begin Delete(s, i, length(s)); break; end;

    vystup := StrToInt(s);
  end;
end;

procedure VyhledejStanici(const nazev: string; odjezd: integer);
begin
end;

// bohuzel pracuje jen v ramci jedne linky a bez kontroly casu:-( 
function TForm1.VyhledejSpojeni(const odkud, kam:string):string;//, pres: string; const odjezd, prestupy, spojeni: integer): string;
var
  node1, node2, node3: IXMLNode;
  i, j, k, st: integer;
  startok: boolean;
begin
  result := '<Spojeni>'#13#10;
  startok := false;
  node1 := XMLDocument1.DocumentElement;
  for i := 0 to node1.ChildNodes.Count - 1 do
  begin
    node2 := node1.ChildNodes[i];
    for j := 0 to node2.ChildNodes.Count - 1 do
    begin
      node3 := node2.ChildNodes[j];
      if node3.NodeName = 'Stanice' then
      begin
        if (node3.NodeValue = odkud) then begin startok := true; st:=j; end;
        if startok and (node3.NodeValue = kam) then
        begin
          result := result + '<Spoj>'#13#10;
          result := result + '<Linka cislo="' + node2.AttributeNodes.FindNode('cislo').NodeValue + '">'+#13#10;
          for k := st to j do
          begin
            result := result + '<Stanice odjezd="'+node3.AttributeNodes.FindNode('odjezd').NodeValue +'">'+node3.NodeValue+'</Stanice>';
          end;
          result := result + '</Linka>'#13#10;
          result := result + '</Spoj>'#13#10;
        end;
      end;
    end;
  end;
  result := result + '</Spojeni>'#13#10;
end;


procedure TForm1.IdHTTPServer1CommandGet(AThread: TIdPeerThread;
  RequestInfo: TIdHTTPRequestInfo; ResponseInfo: TIdHTTPResponseInfo);
var
  node1, node2, node3: IXMLNode;
  i, j: integer;
  stanice: TStringList;
  odpoved, temp: string;
  delka, pozice: integer;

  odkud, kam, pres: string;
  odjezd, prestupy, spojeni: integer;

begin
  Memo1.Lines.Add('Server obdrel pkaz GET');
  stanice := TStringList.Create;
  stanice.Clear;
  if RequestInfo.Document = '/SeznamStanic' then
  begin
    Memo1.Lines.Add('Poslm seznam vech stanic (prosm ekejte)');
    node1 := XMLDocument1.DocumentElement;
    for i := 0 to node1.ChildNodes.Count - 1 do
    begin
      node2 := node1.ChildNodes[i];
      for j := 0 to node2.ChildNodes.Count - 1 do
      begin
        node3 := node2.ChildNodes[j];
        if node3.NodeName = 'Stanice' then
        begin
          stanice.Add(node3.NodeValue);
        end;
      end;
    end;
    stanice.Sort;
    delka := 0;

    // zjisti velikost potrebneho mista pro seznam stanic
    for i := 0 to stanice.Count - 1 do
    begin
      if (i = 0) or ((i > 0) and (AnsiCompareText(stanice[i - 1], stanice[i]) <> 0)) then   // zabrani duplikaci stanic
      begin
        Inc(delka, Length(stanice[i]));
        Inc(delka, 23);
      end;
    end;
    pozice := 1;
    temp := '<SeznamStanic>' + #13#10;
    Inc(delka, 2 * Length(temp) + 1);

    SetLength(odpoved,  delka);

    //temp := 'HTTP/1.0 200 OK'#13#10'Content-type: text/xml'#13#10#13#10;
    //Move(temp[1], odpoved[pozice], Length(temp));
    //Inc(pozice, Length(temp));

    temp := '<SeznamStanic>' + #13#10;
    Move(temp[1], odpoved[pozice], Length(temp));
    Inc(pozice, Length(temp));
    for i := 0 to stanice.Count - 1 do
    begin
      if (i = 0) or ((i > 0) and (AnsiCompareText(stanice[i - 1], stanice[i]) <> 0)) then
      begin
        temp := '  <Stanice>' + stanice[i] + '</Stanice>' + #13#10;
        Move(temp[1], odpoved[pozice], Length(temp));
        Inc(pozice, Length(temp));
      end;
    end;
    temp := '</SeznamStanic>' + #13#10;
    Move(temp[1], odpoved[pozice], Length(temp));
    Inc(pozice, Length(temp));

    stanice.Free;
    ResponseInfo.ContentText := odpoved;
    //ResponseInfo.ResponseText := 'HTTP/1.0 200 OK'#13#10'Content-type: text/xml'#13#10#13#10;

    Memo1.Lines.Add(' ..hotovo');
  end else
  if RequestInfo.Document = '/NajdiSpojeni' then
  begin
    odkud := ''; kam := ''; pres := '';
    odjezd := 0; prestupy := 0; spojeni := 5;
    DateTimeToString(temp, 'hhmm', Now);
    odjezd := StrToInt(temp);
    for i := 0 to RequestInfo.Params.Count - 1 do
    begin
      DostanStrZParametru('odkud', RequestInfo.Params[i], odkud);
      DostanStrZParametru('kam', RequestInfo.Params[i], kam);
      DostanStrZParametru('pres', RequestInfo.Params[i], pres);
      DostanIntZParametru('odjezd', RequestInfo.Params[i], odjezd);
      DostanIntZParametru('prestupy', RequestInfo.Params[i], prestupy);
      DostanIntZParametru('spojeni', RequestInfo.Params[i], spojeni);
    end;
    {Memo1.Lines.Add(odkud);
    Memo1.Lines.Add(kam);
    Memo1.Lines.Add(pres);
    Memo1.Lines.Add(inttostr(odjezd));
    Memo1.Lines.Add(inttostr(prestupy));
    Memo1.Lines.Add(inttostr(spojeni));}
    ResponseInfo.ContentText := VyhledejSpojeni(odkud,kam);
  end else
  begin
    ResponseInfo.ContentText := 'HTTP/1.0 200 OK'#13#10'Content-type: text/xml'#13#10#13#10
     + '<Chyba>Neznamy pozadavek. Nebude zpracovan</Chyba>';
    Memo1.Lines.Add('Neznm poadavek' + RequestInfo.Document);
  end;
end;

end.
